/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
**
** Copyright (C), 2003, Victorian Partnership for Advanced Computing (VPAC) Ltd, 110 Victoria Street, Melbourne, 3053, Australia.
**
** Authors:
**	Stevan M. Quenette, Senior Software Engineer, VPAC. (steve@vpac.org)
**	Patrick D. Sunter, Software Engineer, VPAC. (pds@vpac.org)
**	Luke J. Hodkinson, Computational Engineer, VPAC. (lhodkins@vpac.org)
**	Siew-Ching Tan, Software Engineer, VPAC. (siew@vpac.org)
**	Alan H. Lo, Computational Engineer, VPAC. (alan@vpac.org)
**	Raquibul Hassan, Computational Engineer, VPAC. (raq@vpac.org)
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**
**
**~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include <Base/Foundation/Foundation.h>
#include <Base/IO/IO.h>

#include "types.h"
#include "ChunkArray.h"
#include "BTreeNode.h"

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

const Type BTreeNode_Type = "BTreeNode";

BTreeNode terminal = { BTREE_NODE_BLACK, NULL, 0, 0, NULL, NULL, NULL };

BTreeNode* BTreeNode_New( ChunkArray *pool )
{
	BTreeNode* self;
	
	/* Allocate memory */

	if( pool ){
		unsigned int objID = -1;
		assert( sizeof( BTreeNode ) == pool->elementSize );
		objID = ChunkArray_NewObjectID( BTreeNode, pool );
		
		self = ( BTreeNode* ) ChunkArray_ObjectAt(pool, objID);
		memset ( self, 0, sizeof ( BTreeNode ) );
		
		self->id = objID;
	}
	else{
		self = ( BTreeNode* ) malloc ( sizeof( BTreeNode ) );
		memset ( self, 0, sizeof ( BTreeNode ) );
	}

	assert ( self );
	/* General info */
	
	/* Virtual functions */
	
	/* NamedObject info */
	self->parent = NULL;
	self->left = NIL;
	self->right = NIL;
	self->color = BTREE_NODE_RED;
	_BTreeNode_Init( self );
	
	return self;
}

void _BTreeNode_Init( BTreeNode* self ){
	
	/* General info */
	
	/* Virtual info */
	
	/* BTreeNode info */
	assert ( self );
	self->data = NULL;
	self->sizeOfData = 0;
}



