/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
**
** Copyright (C), 2003, Victorian Partnership for Advanced Computing (VPAC) Ltd, 110 Victoria Street, Melbourne, 3053, Australia.
**
** Authors:
**	Stevan M. Quenette, Senior Software Engineer, VPAC. (steve@vpac.org)
**	Patrick D. Sunter, Software Engineer, VPAC. (pds@vpac.org)
**	Luke J. Hodkinson, Computational Engineer, VPAC. (lhodkins@vpac.org)
**	Siew-Ching Tan, Software Engineer, VPAC. (siew@vpac.org)
**	Alan H. Lo, Computational Engineer, VPAC. (alan@vpac.org)
**	Raquibul Hassan, Computational Engineer, VPAC. (raq@vpac.org)
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**
*/
/** \file
**  Role:
**
** Assumptions:
**
** Invariants:
**
** Comments:
**
**
**~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#ifndef __StGermain_Base_Foundation_debug_hh__
#define __StGermain_Base_Foundation_debug_hh__

#include <stdlib.h>
#include <stdio.h>
#include <setjmp.h>
#include "types.h"

#ifndef NDEBUG

#define ASSERT_FAIL	1

extern Bool	assert_jmpEnabled;
extern jmp_buf	assert_env;

#ifdef stgAssert
#undef stgAssert
#endif
#define stgAssert( e, file, line )						\
   (printf( "%s:%u: failed assertion `%s'\n", file, line, e ), abort(), 0)

#ifdef assert
#undef assert
#endif
#define assert( expr ) ((void)((expr) ? 0 : assert_jmpEnabled ?			\
			     (longjmp( assert_env, ASSERT_FAIL), 0 ) :		\
			     stgAssert( #expr, __FILE__, __LINE__)) )
#else

#ifdef assert
#undef assert
#endif
#define assert( expr ) ((void)0)

#endif

#endif /*__StGermain_Base_Foundation_debug_hh__*/
